// Ejemplo utilizado para el artículo
// ¿ Y tú qué eres ? Identificando clases heredadas en C++
// del blog Poesía Binaria (http://totaki.com/poesiabinaria)
// por Gaspar Fernández <gaspy@totaki.com>

#include <iostream>
#include <string>
#include <vector>
#include <typeinfo>

using namespace std;


class Mascota
{
public:
  Mascota(string nombre):nombre(nombre)
  {
  }
  virtual ~Mascota()
  {
  }

  string getNombre()
  {
    return nombre;
  }
private:
  string nombre;
};

class Perro : public Mascota
{
public:
  Perro(string nombre):Mascota(nombre) 
  {
  }
};

class Gato : public Mascota
{
public:
  Gato(string nombre):Mascota(nombre) 
  {
  }
};

class Iguana : public Mascota
{
public:
  Iguana(string nombre):Mascota(nombre) 
  {
  }
};

int main()
{
  vector <Mascota *>mis_mascotas;
  Mascota *m;
  
  m=new Gato("Mini");
  mis_mascotas.push_back(m);
  m=new Perro("Rufus");
  mis_mascotas.push_back(m);
  m=new Iguana("Igor");
  mis_mascotas.push_back(m);
  m=new Perro("Ralph");
  mis_mascotas.push_back(m);
  m=new Gato("Pitu");
  mis_mascotas.push_back(m);
  m=new Perro("Pluto");
  mis_mascotas.push_back(m);
  m=new Gato("Kity");
  mis_mascotas.push_back(m);
  m=new Iguana("Motorcillo");
  mis_mascotas.push_back(m);

  for (vector<Mascota*>::iterator i=mis_mascotas.begin(); i!=mis_mascotas.end(); i++)
    {
      cout << typeid(**i).name() << endl;
    }
}
